CHANGES
=======

* added email address extraction and normalization
* collect exception deatils
* added more tests
* added notification type and more identifying data at the linking
* user account maintanance + more testing
* Adding change for ORCIDHUB-454 and fixing minor bug of not able to find underscore method
* adde user posting and some tests related to that
* Fixing encoding issue
* Update tests patterns to reduce false positives
* more testing ..
* fixed templates
* fixed test\_link\_orcid\_auth\_callback\_with\_affiliation..
* fixed test\_webhook\_registration
* more fixes
* fixed: test\_create\_or\_update\_property\_record
* fixed orcid login tests
* Fixing unicode error if incorrect encoding is detected
* more fixes
* fixed test\_orcid\_login\_callback\_researcher\_flow
* Fixing bug for status update in case of property record
* Update .deepsource.toml
* Create .deepsource.toml
* Quick fix for user invitation
* fixed test\_property\_api
* fixed test\_member\_api
* fixed test\_org\_webhook
* implemented post for tokens and changes in model
* .
* 
* Increasing unit test coverage
* Increasing coverage
* removed api reprt..
* missing template..
* made backword compatibility with older sqlite3
* fixed: test\_send\_work\_funding\_peer\_review\_invitatio
* fixed test\_enqueue\_user\_records
* fixed: test\_orcid\_api\_rep
* fixed: test\_superuser\_view\_access
* fixed: test\_create\_or\_update\_keyword
* added tests for property task api
* accept \r\n
* fixing unit test
* Minor fix
* Increasing citation\_value max length to 1000
* reverted..
* fix
* fixed: test\_create\_or\_update\_keyword
* fixed:  test\_create\_or\_update\_researcher\_url
* fixed: test\_process\_records
* fixed: tests/test\_views.py::test\_researcher\_invitation
* fixed: tests/test\_views.py::test\_viewmembers
* Changes related to Researcher Other ID batch upload
* Fixing unit tests
* Changes for batch file upload for researchers country/address
* Fixing minor bugs
* ..
* more testing
* removed external IDs from properties..
* added property processing
* accept lowercased citation type
* increase coverage
* fixed formatting
* increase coverage
* more tests
* Changes for ORCIDHUB-488; Adding ability for admins to add/delete/update individual Other IDs information
* fixed tests
* Adding changes for ORCIDHUB-448; Adding ability for admin to Edit/Add/Delete Address information for researcher
* more tests
* fixed tests
* ..
* so far..
* completed property apis
* Increasing coverage
* Fixing unit test
* added backward compatibility...
* Adjusting case sensitivity as per orcid requirements for external ids and also fixing error messages
* so far.
* Fixing unit test
* fixing single reset for invitees
* partially refactored url, other names, keywords handling makde into more gneric way to handle that..
* Fixing individual reset in batch process
* Emphasise the login instructions
* Remove unnecessary SSL cert reference from install instructions Update C&C Badges to 2019 Misc typos Reclaim some view realestate with funding, works, and peer-review Better explanation of how to use hub on home page
* a few improvements
* Minor changes for related ORCIDHUB-445
* Changes for enabling org admins and tech contacts to invite themselves
* Changes for ORCIDHUB-447, adding education and employment as affiliation types
* Fixing attributeError while writing affiliation records
* fixed temporary tests
* fixed result\_ttl and added more tests
* Minor changes to ask Admins to verify email address under ORCID profile settings while onboarding on HUB via ORCID
* fixed tests
* fixed rest of tests
* fixed testing
* added '.' as date part separator
* fixed processing and increased coverage
* added enqueuing of the record processing when the record gets updated..
* fixed tests
* subpress emailing..
* fixed a few tests
* more testing
* completed activete\_all and reset\_all and improved testing
* improvements to simplify testing
* make process\_\*\_recores async executable
* add org data from organisiations for orgs missing in the org\_info list
* fix
* temporary fix for queing, but need to figure out how to display audit table without breaking rq
* more logging
* extra logging for worker
* fixed handing or exports and imports
* more test assets
* import or othernames improved and added tests
* adjusted schema
* unit test
* fixed tests and case with the leap year
* placed input validation into the write palce
* Fixing travis
* Fixing bug for onboarding tuakiri organisation and making the onboarding consistent with user edit functionality
* Fixing onboarding via tuakiri in WTFForm as Required is now deprecated and now DataRequired is being used
* quickfix: wrong SP domainname for prod..
* more mocking
* ..
* added more validations and tests
* fixed tests
* more tests
* fixed tests
* Minor fixes
* raise exception if the DKIM file is missing + minor improvements
* Flat file upload changes for peer review records
* Changes for funding flat file
* remove audit log creation at start up
* fixed condition for log views
* Fixing export for flat file to export only one external id
* added log views coditionally..
* Travis fix
* Fixing work flat file export
* remove techcontact role if the user is not a tech.contact of any other org
* more testing..
* fixed tests
* Changes for flat file upload for works without contributors
* fixed tests
* fixed flakes..
* refactored recored child record CRUD
* Minor change
* Travis fix
* Fixing DKIM issue
* missing arguments
* so far..
* fixed test
* added attributes and improved api model schema..
* added attributes and improved api model schema..
* fixed and added tests
* ..
* ..
* ..
* ..
* ..
* ..
* ..
* ..
* ..
* ..
* removed unnecessary file
* removed swagger v3.0 version features
* improved performance and formatting..
* improved peer review form
* fixed flakes
* invoke validation only for record forms
* refactored the forms for url, keywords, and other names
* fixed tests
* fixed peer-review loading
* fixed load of funding data
* added other name editing
* fixed json loading..
* fixed few tests
* fixed models
* refactored researcher urls
* added creation of peer review batch processing data
* Changes after code review
* added creation of funing records
* Fixing merge issue
* Update orcid\_api\_proxy.rst
* increase coverage
* fixed invitees..
* fixed tests
* Adding missing data
* Adding unit test
* Completing the changes for uploading Keywords json/yaml/csv/tsv file
* handle case without filename whit timestamp
* handle case without filename
* added import of peer reviews
* Travis fix
* Changes for uploading keyword batch file
* Update README.md
* Increasing coverage
* improved test output..
* Changes for ORCIDHUB-432; to fix contibutor-sequence in flat work upload
* added testing for peer-review api
* added entry points for peer-reviews
* Fixing ORCIDHUB-435; to write Work contributor Role even if contributor sequence is not present
* added task audit trail log and log views for orgs, users, and tasks
* flake config to check coplexity..
* Remove unnecessary SSL cert reference from install instructions
* General tidy and install guide
* Install from PyPI or Source
* fix
* Changes for discarding the row in flat file when the row is empty
* Changes for ORCIDHUB-434, to allow null value in citation info of work record
* Fixing RQ process\_tasks call after recent db changes
* refacotred tests
* more mocking around
* fixed pyinfo
* capture event propagation

4.16.6
------

* quickfix of sample configuration
* mock out logging to prevent event propagation to Sentry
* Showing the correct message of missing work type

4.16.5
------

* Changes for ORCIDHUB-428; trimming disambiguated\_id and disambiguated\_source to remove whitespaces at the start and end
* making the edit components smaller
* Fixing Flask Admin UI
* Adding missing lower case condition
* Fixing csv loading for windows as the file content\_type on windows differs from unix system
* Adding changes to send person/update invite
* Changes for keywords record deletion through UI
* Changes for ORCIDHUB-396; changes for Keywords UI
* Completing the changes for researcher url and other name UI
* increase coverage..
* fixed menu
* disable webhook menu entry for non-technical contacts..
* fixed HEAD method
* everything fixed..
* refactoring
* so far..
* Adding more changes
* Fixing travis-ci
* Showing list of Researcher Url and Other Names associated with the user
* fixed tests
* fixed funing api
* fixed spelling
* refactored again and added stubs for works
* refactored code to support the rest of uploaded formts..
* imroved layout of eidit form elements on UI
* Adding changes to make funding, peer-review, affiliations icons hidden by default and display them when hover over edit on view members page
* quickfix: relative instance settings.cfg

4.16.4
------

* refessed dev docker image with twine..
* running twine from docker
* let's rock-&-roll
* let's rock-&-roll

4.16.2
------

* let's rock-&-roll
* let's rocken-roll
* move from V4 to prod
* more details
* Increasing coverage
* it might be helpful
* resolved conflict..
* Update virtualbox.rst
* documentation quickfix
* documentation quickfix
* Update docker.rst
* Adding unit test

4.16.0
------

* fixed rst
* spelling, README converted into restructoredtext..
* use relative instnces directory relative to the current directory
* Changes to support csv/tsv format for uploading researcher urls and other names record files

4.2.0
-----

* code cleanup
* Schema fix
* addded section on ORCID API Proxy..
* reformatted and fixed spelling..
* fixed test\_view
* fixed test\_utils
* fixed test\_orcid
* fixed test\_apis
* fixed test\_main.py
* a few improvements: 1) replaced request\_ctx with app fixture; 2) refacored old tests
* Fixing unit test
* Adding Unit test to increase coverage
* PosgtgreSQL bugfixes, rebuilt app image
* freezed dependencies of RQ
* updated to support Python 3.7
* Adding schema validation for researcher url and other name batch file
* missing redis directory
* get rid of redundant branching
* attemp to upgrade to python 3.7
* can't add reis folder, issues with permissions
* inproved documentation on the webhooks
* improved documentation
* improve the documentation
* more testing ..
* long overdue refactoring of the configuration
* FIxing unit test
* more testing
* Completing and fixing bugs for ORCIDHUB-388/398
* ..
* quickfix
* ..
* ..
* ..
* fixed pipeline
* fixed pipeline
* Update docker.rst
* suply DB URL for falsk command
* fixed role update
* sso-loging
* a few improvements
* default SUBNET to 172.33
* Update docker.rst
* ..
* Update docker-compose.yml
* Update docker.rst
* Update virtualbox.rst
* Rename virtual\_box.rst to virtualbox.rst
* Create virtual\_box.rst
* quickfix
* allow to expose the app ports
* webapp service ..
* Update docker.rst
* improved key generation..
* Update docker.rst
* create all directories via git repo
* skip shibboleth if EXTERNAL\_SP is set..
* Complete changes for ORCIDHUB-388 and ORCIDHUB-398
* Update docker.rst
* Creating or updating researcher url through orcid call
* Changes for sending email invitation to researcher in order get /Person/Update permission
* fixed tests
* ..
* increased the coverage
* fixed tests: username property should be immutable
* added 'username' property to Usser to comply with Flask-Login spec
* fixed Shibboleth installation and added testing form Exceptions
* Making the researcher url file upload simpler by removing invitees block
* fixed formatting..
* upgrade to the new sentry sdk
* Updating links for Installing Shibboleth SP
* fixed callback url for 'localhost'
* Completing changes for uploading Research Url Json/Yaml file
* Changes for uploading researcher url batch file
* quickfix: direct ORCID authenticaion for DEV environment if CLIEN\_ID is given
* allow redirect to localhost
* imroved documentation
* Update docker.rst
* Adding contributors data in CV download function as well
* Adding contributors data in CV and Displaying works information in APA Format
* handle case when order clause defined witha string..
* adde extra order\_by by IF if sorting done by NULLable field
* fixed audit trail talbe ownership, fixed task view
* added is\_deleted ..
* Orcidhub 404 (#636)
* test git-attributes
* images for the webhook documentation
* fixed spelling in the model module (#631)
* Quick fix for yaml funding upload; making the output to be NestedDict. (#635)
* V4 (#632)
* Orcidhub 383 (#634)
* rebuild image... (#633)
* meh..
* fixed spelling in the model module
* Orcidhub 362 (#630)
* V4 (#629)
* Fixing flake
* Add about ORCID to home page
* Add about ORCID to default email
* Fixing Url display as per ORCID guideline
* Minor change after code review
* Changes for ORCIDHUB-409; setting the external ids in orcid call based on there order of upload
* Unit test fix
* Changes for ORCIDHUB-408
* added swagger schema for orcid api proxy (#625)
* Bug fix for ORCIDHUB-368
* Adding Unit test for fixing coverage
* Fixing json/yaml export for work records
* slightly changed UI and added a few tooltips (#624)
* Fixing json/yaml export for funding records
* Unit test fix
* Minor bug fix for enforcing email address to be in lower case and fixing sentry warning
* Changes for fixing yaml and json export for peer reviews
* added SSL support to PostgreSQL
* added more views for improving troubleshooting (#623)
* fix..
* Orcidhub 380 (#622)
* fixed rate limiter
* disbale TLS 1.0
* added access to PG and fixed header to set up remote address correctly
* fix for app running behind a proxy
* increased the ratelimit for status check
* Orcidhub 380 (#621)
* changed configuration to support mutli-environtment on the same box
* fixed backup script
* updated docs and configuration
* Warning message fix
* Orcidhub 372 csv/tsv for peer reviews (#620)
* Completing the changes for Peer review TSV/CSV upload
* Adding csv/tsv for peer review
* Fixing unit test
* Minor bug fix for CVS/TSV upload for works and funding
* Orcidhub 370 (#618)
* Orcidhub 382 (#619)
* Minor bug fix after recent changes
* simpified the inviation handling and added more tests
* Changes for manual form for work, peerreview and funding where the external ids should be opened with empty field as there is need of alteast one
* added logging
* reuse the sate
* handle encodings with BOMs (#617)
* Orcidhub 369 (#616)
* handle encodings with BOMs
* Saving both ORCiD iD and put-code even when affiliation record remain unchanged. i.e, when no update or create affilaition record call is made
* V4 fix (#614)
* Fixing the bug related to orcid token fetching
* fixed dependencies for testing
* Fixing multiple email sending in case of affiliation records while doing reset
* added safeConfirm for backward compatibility..
* test for hangling wrong or missig country codes
* fixed image building
* quickfix
* Orcidhub 369 (#611)
* Orcidhub 377 (#612)
* added peer review export with related records; refactored code for the rest of reviews (#610)
* V4 (#608)
* added peer review export with related records; refactored code for the rest of reviews
* added csv/tsv upload (#609)
* Orcidhub 365 (#607)
* Orcidhub 364 (#606)
* Orcidhub 361 (#604)
* fixed dependencies
* improeved image building..
* Bug fix of end date
* Orcidhub 361 (#602) (#603)
* Orcidhub 361 (#602)
* Completed the changes for CV generation
* Changes related to part 1 of CV
* Changes related to CV
* Changes related to CV generation; personal details section
* Orcidhub 361 (#598)
* Adding changes for CV template
* title..
* quickfix ..
* quickfix of archiving command
* Orcidhub 357 (#595)
* customized message and added more tests (#596)
* fix
* quick fix
* Orcidhub 352 (#593)
* fixed conflict..
* Orcidhub 352 (#592)
* spelling ..
* test permissions to access profile sync page
* Orcidhub 352 (#589)
* ..
* ..
* ..
* ..
* ..
* Fixing the case where multiple email were sent to the user as ORCID ID was common with those users belonging to two different organisations
* increased the coverage
* even more..
* increase the coverage..
* fixed tests
* restructured tests
* fixing travis flake build
* improved pagination
* added pagination and fixed task list
* added log entry to show that user processing was completed
* removed unused code
* fixed test
* missing template
* added form and tests
* Minor fix
* Enabling researchers  to remove token and ORCiD iD; i.e. erroneous linkage made, However Admins cant remove its own ORCiD iD
* implemented sync and added tests
* added task logging and improved model namings (#583)
* Orcidhub 28 (#584)
* ..
* fixed tests
* added task logging and improved model namings
* Orcidhub 350 (#582)
* default disambiguated\_id wasnt getting picked. (#581)
* fixing inner join bug which was causing email sending issues
* disable CV for production branch
* fixed tests
* exclude generated load testing data
* Fixing bug for ORCIDHUB-341; removing double forward slash
* Changes after code review
* Fixing issue of session state mismatch
* Fixing unit test
* Adding more unit test to Increasing coverage
* Increasing coverage
* Increasing test coverage
* adjusted parameters..
* fixed more tests and addes docs on load testing..
* added section on the load testing..
* Adding unit test to increase coverage
* V4 (#577)
* Loging for testing (#576)
* V4 (#575)
* Removing extra external id block from peer review and funding
* Fixing bugs for funding and peer review Ui edit
* Fixing validators for peer review entry
* ..
* Completing the changes for peer review UI edit
* Adding list of external ids to peer review ui edit
* fixed more tests
* refactored tests
* Adding fields in UI
* improved formatting..
* Adding UI changes for Peer review
* fix tests
* fixed test
* bump up PostgreSQL to 10.5... there are a few critical bugs fixed
* added documentation about application registration
* Changes to view list of peer review items associated with ORCiD iD
* Updating changes from recent ORCID Swagger json related to peer reviews
* fixed connection strings (#572)
* improved admin UI and testiong (#571)
* Displaying correct message to user in case of token expired, after recent changes and merges the code that displays token expired message became unreachable, so making it reachable
* Travis fix
* Fixing the bug of multiple email sent when Admin does reset for tasks which has  ORCID iD belonging to multiple organisation
* Orcidhub 318 (#568)
* Bug fix for peer review; Mulitple emails were getting sent when the peer invitee block had ORCID iD associated with multiple organisations
* updating V4 with latest changes. (#567)
* Added extra bit for detecting encoding in uploaded file, but does not detect correct encoding 100% of time, so the current change should work well with other exsisting encoding check
* V4 (#565)
* Orcidhub 337 (#564)
* Orcidhub 321 (#563)
* Orcidhub 336 (#562)
* link LOAD\_TEST host env to the container
* V4 (#561)
* Update test\_views.py
* Update views.py
* Loaging for testing (#560)
* Orcidhub 306 (#559)
* added docs about Shibboleth configuration (#558)
* user HTTPS for for invitation links for non-dev environments (#557)
* Orcidhub 294 (#555)
* fixed tests
* filled CV with some data from the profile
* deserialize JSON into a nested dict
* quickfix: missing DB connection
* Orcidhub 223 (#538)
* added 'preview'
* experimenting with media..
* Orcidhub 294 (#550)
* missing templates
* fixed tests..
* fix..
* improved CV generation and fixed some UI stuff
* V4 (#548)
* reference to nonexisting column ..
* improved formatting..
* fixed counts..
* fix: testing
* added fileter and more testing..
* added basic bits for CV generation..
* refactored code.
* improved coverage and mande some adjustments
* added on\_delete to all foreign keys
* Shuffling toc and fixing md heading levels
* One ORCID iD cannot be associated with two different email address of same organisation
* Fixing unit test
* If the email is already associated with an ORCID iD and user is trying to login with different ORCID iD then asking the user to login with correct ORCID iD
* Showing correct API exception from ORCID
* Production patch for allowing edupersonaffiliation other than staff, student or faculty
* Completing the changes for Funding-UI
* Adding code to delete funding entry from UI
* Changes for creating or updating individual funding through UI
* improved performance..
* fix: alternative cover in the test
* Correct modal TK tooltip
* Changing contributor email guidance
* Adding affiliation examples
* Update writing\_affiliation\_items.rst
* doc update
* doc update
* Fixing merge
* fixing unit test
* Unit test and minor fix
* fixed WAL archiving ... [skip ci'
* ... [skip ci]
* added update of the 'dummy' profile entry
* Changes for ORCIDHUB-192 and ORCIDHUB-193
* added tooltips..
* added retrieval of full researcher profile; DOTO: sync entries with CSV
* Putting ORCID ID in affiliation Records
* fixed tests: select/first does't raise an exeption; added another test..
* fix: look for the user by alernative emails and/or eppn
* Travis-fix
* Minor change
* Bug fix
* Employment and Education record creation fix
* admin UI improvements ..
* show the tracking stats on the edit page
* added api credential requestiong handlinbg..
* model changes ..
* workaround to exclude duplicates..
* removed zipped swagger client..
* removed debugging..
* mandated flake8 validation..
* added reporting test ..
* fixed documentation ..
* fixed tests and reports..
* Updating the changes for ORCIDHUB-173
* ..
* fixed modes.py
* fixed formatting..
* no need for \_\_init\_\_.py with python 3
* Seperate Audit trial for ORCID Authorize Call
* Update authcontroller.py
* improved mail lontent, removed .plain to reduce code footprint
* re-addded errror handling and more meat to the invitation message
* added 'external id' import ..
* quick fix: missing template ..
* [skip ci] added External ID
* improved message and refactored email templates..
* single uer invitation handling
* Update index.html
* improved uploaded file validattion
* Typo and small change in wording
* Update fileUpload.html
* let's user 'disambiguated\_id' and 'disambiguation\_source'..
* Adding Audit trails for authorisation
* improved data modification using a single UPDATE ..
* imroved UI..
* workaround for row actions..
* improved sinle user inviation. minor formatting improvements..
